# Lenovo ThinkCentre Cluster

### Ausstattung:

* 5 x ThinkCentre M710q bis M920q
* 5 x 1TB Cruical NVME
  * 500 GB Proxmox
  * 431 GB frei für CEPH

```
    Device                                          Start                      End                  Sectors                 Size Type
    /dev/nvme0n1p1                                     34                     2047                     2014                1007K BIOS boot
    /dev/nvme0n1p2                                   2048                  2099199                  2097152                   1G EFI System
    /dev/nvme0n1p3                                2099200               1048576000               1046476801                 499G Linux LVM
    Free space                                 1048578048               1953525134                904947087               431.5G    
```

### Tweaks:

* Intel E1000 Probleme mit ehttool beseitigen:
```
iface eno1 inet manual
        post-up /usr/sbin/ethtool -K $IFACE tso off gso off 2> /dev/null
```
* Update auf die neueste Proxmox-Version
* Einrichten der no-subscription Repos
* Installiere Unterstützung für VirtIO-GL
```
apt update ; apt install -y libgl1 libegl1 hwinfo btop; apt dist-upgrade -y
```

### Reihenfolge:

* Alle Nodes mit Proxmox installieren und auf den neuesten Stand updaten.
* vmbr0 einrichten: VLAN Aware! 
* Ein eigenes VLAN für Corosync und CEPH einrichten, z.B VLAN Interface vmbr.100 (siehe unten: interfaces Datei)
* Auf dem ersten Node den Cluster erstellen und VLAN 100 für Corosync & CEPH auswählen
* Testen ob der Cluster ordnungsgemäß funktioniert
* CEPH installieren

### CEPH:

* Zuerst auf allen Nodes die CEPH-pakete installieren:
```
pveceph install --version reef --repository no-subscription
```
* Danach kann CEPH initialisiert werden:
```
pveceph init --network 10.23.66.0/24
```

### /etc/network/interfaces:
```
auto lo
iface lo inet loopback

iface eno1 inet manual
        post-up /usr/sbin/ethtool -K $IFACE tso off gso off 2> /dev/null

auto vmbr0
iface vmbr0 inet static
        address 192.168.177.2/21
        gateway 192.168.179.1
        bridge-ports eno1
        bridge-stp off
        bridge-fd 0
        bridge-vlan-aware yes
        bridge-vids 2-4094

auto vmbr0.2366
iface vmbr0.2366 inet static
        address 10.23.66.2/24
#Corosync & CEPH
```